# DataPipeline.jl

**The [FAIR Data Pipeline][dp_docs] in Julia**

| **Documentation** | **Build Status**           | **DOI**                    |
|:-----------------:|:--------------------------:|:--------------------------:|
| [![stable docs][docs-stable-img]][docs-stable-url] | [![Package Testing][testing-img]][testing-url] | [![Zenodo][zenodo-badge]][zenodo-url] |
| [![dev docs][docs-dev-img]][docs-dev-url] | [![Julia Nightly][nightly-img]][nightly-url] | |

## Features

- Conveniently download Data Products from the [SCRC Data Registry](https://data.scrc.uk/).
- File hash-based version checking: new data is downloaded only when necessary.
- A SQLite layer for convenient pre-processing (typically aggregation, and the joining of disparate datasets based on common identifiers.)
- Easily register model code or realisations (i.e. 'runs') with a single line of code.

## Installation

The package is now registered with General and can be added via the package manager Pkg. From the REPL type `]` to enter Pkg mode and run:

```julia
pkg> add DataPipeline
```

## Usage

See the [package documentation][docs] for instructions and examples.

[docs]: https://fairdatapipeline.github.io/DataPipeline.jl/stable/

[dp_docs]: https://fairdatapipeline.github.io/docs/introduction/

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://fairdatapipeline.github.io/DataPipeline.jl/stable/

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://fairdatapipeline.github.io/DataPipeline.jl/dev/

[testing-img]: https://github.com/FAIRDataPipeline/DataPipeline.jl/actions/workflows/testing.yaml/badge.svg
[testing-url]: https://github.com/FAIRDataPipeline/DataPipeline.jl/actions/workflows/testing.yaml

[nightly-img]: https://github.com/FAIRDataPipeline/DataPipeline.jl/actions/workflows/nightly.yaml/badge.svg
[nightly-url]: https://github.com/FAIRDataPipeline/DataPipeline.jl/actions/workflows/nightly.yaml

[zenodo-badge]: https://zenodo.org/badge/302237736.svg
[zenodo-url]: https://zenodo.org/badge/latestdoi/302237736
